routes/admin.php
<?php

use App\Http\Controllers\AdminControllers\AuthController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AdminControllers\DashboardController;


Route::get('/login', [AuthController::class, 'login_page'])->name('admin.login_page');
Route::post('/login', [AuthController::class, 'login'])->name('admin.login');




/*All Admin Routes List*/
Route::middleware(['auth', 'user-access:admin'])->namespace('App\Http\Controllers\AdminControllers')->group(function () {
    Route::get('/dashboard', [DashboardController::class, 'dashboard'])->name('admin.dashboard');

    //students
    Route::resource('students', 'StudentController');
    //teachers
    Route::resource('teachers', 'TeacherController');
    //extensions
    Route::resource('extensions', 'ExtensionController');
    //levels
    Route::resource('levels', 'LevelController');
    //categories
    Route::resource('categories', 'CategoryController');
    //skills
    Route::resource('skills', 'SkillController');
    //courses
    Route::resource('courses', 'CourseController');

    //curriculums
    Route::resource('curriculums', 'CurriculumController');

    //scheduled
    Route::resource('scheduleds', 'ScheduledController');

    //units
    Route::resource('units', 'UnitController');

    //lessons
    Route::resource('lessons', 'LessonController');

    Route::get('moduleFile/destroy/{id}', [\App\Http\Controllers\AdminControllers\CurriculumController::class,'moduleFileDestroy'])->name('moduleFile.destroy');


    //Sprint 3
    //calendars
    Route::resource('calendars', 'CalendarController');
    //calendar Questions
    Route::resource('calendar_questions', 'CalendarQuestionController');
    //calendar answers
    Route::resource('calendar_answers', 'CalendarAnswerController');



});

routes/web.php
<?php

use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\WebsiteControllers\CalendarController;
use App\Http\Controllers\WebsiteControllers\CourseController;
use App\Http\Controllers\WebsiteControllers\CurriculumController;
use App\Http\Controllers\WebsiteControllers\LessonController;
use App\Http\Controllers\WebsiteControllers\ScheduledController;
use App\Http\Controllers\WebsiteControllers\UnitController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\WebsiteControllers\HomePageController;
use App\Http\Controllers\WebsiteControllers\TeacherController;
use App\Http\Controllers\WebsiteControllers\SkillController;
use App\Http\Controllers\WebsiteControllers\CategoryController;
use App\Http\Controllers\StudentControllers\AuthController;
use App\Http\Controllers\StudentControllers\DashboardController;


//Auth::routes();
Route::get('/student/register', [AuthController::class, 'register_page'])->name('website.student.register_page');
Route::post('/student/register', [AuthController::class, 'register'])->name('website.student.register');
Route::get('/student/login', [AuthController::class, 'login_page'])->name('website.student.login_page');
Route::post('/student/login', [AuthController::class, 'login'])->name('website.student.login');
Route::post('/logout', [LoginController::class, 'logout'])->name('logout');
Route::get('/forget_password', [AuthController::class, 'forget_password'])->name('website.forget_password');
Route::post('/reset_password', [AuthController::class, 'reset_password'])->name('website.reset_password');
Route::get('/reset_password/{token}', [AuthController::class, 'change_reset_password'])->name('website.change_reset_password');
Route::post('/change_reset_password', [AuthController::class, 'change_reset_password_post'])->name('website.change_reset_password');
Route::get('/verification_email/{encryptID}', [AuthController::class, 'verification_email'])->name('website.verification_email');

Route::get('/', [HomePageController::class, 'index'])->name('website.index');

Route::middleware('auth')->group(function(){
    Route::get('/teachers', [TeacherController::class, 'index'])->name('website.teachers.index');
    Route::get('/teacher/{id}', [TeacherController::class, 'show'])->name('website.teachers.show');
    Route::get('/skills', [SkillController::class, 'index'])->name('website.skills.index');
    Route::get('/skill/{id}', [SkillController::class, 'show'])->name('website.skills.show');
    Route::get('/categories', [CategoryController::class, 'index'])->name('website.categories.index');
    Route::get('/category/{id}', [CategoryController::class, 'show'])->name('website.categories.show');
    Route::get('/courses', [CourseController::class, 'index'])->name('website.courses.index');
    Route::get('/course/{id}', [CourseController::class, 'show'])->name('website.courses.show');
    Route::get('/curriculums', [CurriculumController::class, 'index'])->name('website.curriculums.index');
    Route::get('/curriculum/{id}', [CurriculumController::class, 'show'])->name('website.curriculums.show');
    Route::get('/scheduled/{id}', [ScheduledController::class, 'show'])->name('website.scheduleds.show');
    Route::get('/unit/{id}', [UnitController::class, 'show'])->name('website.units.show');
    Route::get('/lesson/{id}', [LessonController::class, 'show'])->name('website.lessons.show');

    Route::post('/student_upload_course_file_answers/{id}', [CourseController::class, 'studentUploadCourseFileAnswers'])->name('website.courses.studentUploadCourseFileAnswers');
    Route::get('/student_delete_course_file_answers/{id}', [CourseController::class, 'studentDeleteCourseFileAnswers'])->name('website.courses.deleteUserFile');

    Route::post('/student_ask_question_course/{id}', [CourseController::class, 'studentAskQuestion'])->name('website.courses.studentAskQuestion');
    Route::get('/student_delete_question_course/{id}', [CourseController::class, 'studentDeleteCourseQuestion'])->name('website.courses.deleteUserQuestion');

    Route::get('/myFavorite/{id}', [CourseController::class, 'addToFavorite'])->name('website.courses.addToFavorite');
    Route::get('/myFavorite', [CourseController::class, 'myFavorite'])->name('website.courses.myFavorite');
    Route::get('/removeFromFavorite/{id}', [CourseController::class, 'removeFromFavorite'])->name('website.courses.removeFromFavorite');
    Route::post('/rating/{id}', [CourseController::class, 'rating'])->name('website.courses.rating');



    //Calendars Routes
    Route::get('/calendar/show/{id}', [CalendarController::class, 'show'])->name('website.calendars.show');
    Route::get('/calendar/go_exam/{id}', [CalendarController::class, 'go_exam'])->name('website.calendars.go');
    Route::post('/calendar/save_exam/{id}', [CalendarController::class, 'save_exam'])->name('website.calendar.save_exam');
    Route::get('/calendar/finished_exam/thanks', [CalendarController::class, 'thanks_after_finished'])->name('website.calendars.thanks');




});



/*All Normal Students Routes List*/
Route::middleware(['auth', 'user-access:student'])->group(function () {
    Route::get('/student/dashboard', [DashboardController::class, 'dashboard'])->name('website.student.dashboard');
    Route::post('/student/update', [DashboardController::class, 'update'])->name('website.student.update');

    Route::get('/student/calendars', [DashboardController::class, 'myCalendars'])->name('website.student.calendars');

});

app/Models/Scheduled.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Scheduled extends Model
{
    use HasFactory;
    protected $guarded = [''];


    public function files()
    {
        return $this->hasMany('App\Models\ModuleFile', 'module_id','id')->where('module_name', 'Scheduled');
    }

    public function category()
    {
        return $this->belongsTo('App\Models\Category', 'category_id')->whereStatus('yes');
    }

    public function curriculum()
    {
        return $this->belongsTo('App\Models\Curriculum', 'curriculum_id')->whereStatus('yes');
    }

    public function units()
    {
        return $this->hasMany('App\Models\Unit', 'scheduled_id')->whereStatus('yes');
    }

    public function courses()
    {
        return $this->hasMany('App\Models\Course', 'scheduled_id')->whereStatus('yes');
    }



}

app/Http/Controllers/AdminControllers/ScheduledController.php
<?php

namespace App\Http\Controllers\AdminControllers;

use App\Http\Controllers\Controller;
use App\Http\Traits\HelperTrait;
use App\Models\Category;
use App\Models\Curriculum;
use App\Models\ModuleFile;
use Illuminate\Http\Request;
use App\Http\Requests\ScheduledRequest;
use App\Models\Scheduled;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;

class ScheduledController extends Controller
{
    use HelperTrait;

    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $content = Scheduled::with(['curriculum','category'])->orderBy('sort', 'asc')->paginate($this->paginate);
        return view('admin_dashboard.scheduleds.index' , compact('content'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $categories = Category::whereStatus('yes')->orderBy('sort', 'asc')->pluck('id', 'title');
        $curriculums = Curriculum::whereStatus('yes')->orderBy('sort', 'asc')->pluck('id', 'title');

        return view('admin_dashboard.scheduleds.create', compact('categories','curriculums'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(ScheduledRequest $request)
    {
        $data = $request->validated();
        DB::beginTransaction();
        try {
            //upload Image
            $image = $this->upload_file_helper_trait($request,'image', 'uploads/');
            $data['image'] = $image;
            isset($data['status']) ? $data['status']='yes' : $data['status'] = 'no';
            $created = Scheduled::create($data);
            //Save Multiple Files
            $this->saveMultipleFiles('Scheduled', $created->id, $data,'uploads/');
            DB::commit();
            toastr()->success($this->insertMsg, 'نجح', ['timeOut' => 5000]);
            return redirect()->back();
        } catch (\Exception $e) {
            DB::rollback();
            toastr()->error($this->error, 'فشل', ['timeOut' => 5000]);
            return redirect()->back();
        }
    }


    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Scheduled $scheduled)
    {
        $content =  $scheduled;
        $categories = Category::whereStatus('yes')->orderBy('sort', 'asc')->pluck('id', 'title');
        $curriculums = Curriculum::whereStatus('yes')->orderBy('sort', 'asc')->pluck('id', 'title');
        return view('admin_dashboard.Scheduleds.edit', compact('curriculums','content','categories'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(ScheduledRequest $request, Scheduled $scheduled)
    {
        $data = $request->validated();
        if($request->hasFile('image')){
            $image = $this->upload_file_helper_trait($request,'image', 'uploads/');
            $data['image'] = $image;
        }
        isset($data['status']) ? $data['status']='yes' : $data['status'] = 'no';
        $scheduled->update($data);
        if($request->hasFile('file_uploaded'))
        {
            $this->saveMultipleFiles('Scheduled', $scheduled->id, $data,'uploads/');
        }
        toastr()->success($this->updateMsg, 'نجح', ['timeOut' => 5000]);
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Scheduled $scheduled)
    {
        $scheduled->files()->delete();
        $scheduled->delete();
        toastr()->success($this->deleteMsg, 'نجح', ['timeOut' => 5000]);
        return redirect()->back();
    }



}

app/Http/Controllers/WebsiteControllers/ScheduledController.php
<?php

namespace App\Http\Controllers\WebsiteControllers;

use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\Course;
use App\Models\Curriculum;
use App\Models\Scheduled;
use Illuminate\Http\Request;

class ScheduledController extends Controller
{

    //show
    public function show($id)
    {
        $content = Scheduled::with(['courses','units', 'files'])->whereStatus('yes')->whereId($id)->first();
        if(!$content)
        {
            return abort(404);
        }
        $page_title = $content->title;
        $subTitle = '<a href="'.route('website.curriculums.index').'">مناهجي</a>' .' / '.'<a href="'.route('website.curriculums.show',$content->curriculum?->id).'">'.$content->curriculum?->title.'</a>' .' / '. $content->title;

        return view('website.single_scheduled', compact('content','page_title','subTitle'));
    }


}

resources/views/admin_dashboard/scheduleds/create.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title')  المقرر | إضافة   @endsection

@section('content')

    <div class="row">
        <div class="col-lg-12 mx-auto">
            <div class="card">
                <div class="card-body">
                    <div class="d-flex align-items-center">
                        <h5 class="mb-0"> <i class="lni lni-book"></i> المقرر | اضافة عنصر جديد </h5>
                    </div>
                    <div class="row g-3 mt-4">
                        <div class="col-12">
                            <div class="card shadow-none bg-light border">
                                <div class="card-body">
                                    <form class="row g-3" id="validateForm" method="post" enctype="multipart/form-data"
                                    action="{{route('scheduleds.store')}}">
                                        @csrf

                                        <div class="col-12">
                                            <label class="form-label">  اختر المنهج <span class="text-danger">*</span> </label>
                                            <select class="form-control" name="curriculum_id">
                                                <option value="">اختر المنهج</option>
                                                @foreach($curriculums as $key=>$val)
                                                    <option value="{{$val}}">{{$key}}</option>
                                                @endforeach
                                            </select>
                                        </div>

                                        <div class="col-12">
                                            <label class="form-label">  اختر المجال <span class="text-danger">*</span> </label>
                                            <select class="form-control" name="category_id">
                                                <option value="">اختر المجال</option>
                                                @foreach($categories as $key=>$val)
                                                    <option value="{{$val}}">{{$key}}</option>
                                                @endforeach
                                            </select>
                                        </div>

                                        @include('admin_dashboard.inputs.title')
                                        @include('admin_dashboard.inputs.short_description')
                                        @include('admin_dashboard.inputs.image')
                                        @include('admin_dashboard.inputs.SEO_inputs')
                                        @include('admin_dashboard.inputs.status_sort')

                                        @include('admin_dashboard.inputs.multiple_files')

                                        @include('admin_dashboard.inputs.add_btn')
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div><!--end row-->
                </div>
            </div>
        </div>
    </div>

@endsection

@push('scripts')
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.5/jquery.validate.min.js" integrity="sha512-rstIgDs0xPgmG6RX1Aba4KV5cWJbAMcvRCVmglpam9SoHZiUCyQVDdH2LPlxoHtrv17XWblE/V/PP+Tr04hbtA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script>
    $(document).ready(function () {
        $("#validateForm").validate({
            rules: {
                category_id: {
                    required: true,
                },
                title: {
                    required: true,
                },
                short_description: {
                    required: true,
                },
                image: {
                    required: true,
                },
                "name[]": {
                    required: true,
                },
                "file_type[]": {
                    required: true,
                },
                "file_uploaded[]": {
                    required: true,
                },

            },
            messages: {
                category_id: {
                    required: "الحقل مطلوب",
                },
                title: {
                    required: "الحقل مطلوب",
                },
                short_description: {
                    required: "الحقل مطلوب",
                },
                image: {
                    required: "الحقل مطلوب",
                },
                "name[]": {
                    required: "الحقل مطلوب",
                },
                "file_type[]": {
                    required: "الحقل مطلوب",
                },
                "file_uploaded[]": {
                    required: "الحقل مطلوب",
                },

            }
        });
    });
</script>
@endpush

resources/views/admin_dashboard/scheduleds/edit.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title')  المقرر | تعديل   @endsection

@section('content')

    <div class="row">
        <div class="col-lg-12 mx-auto">
            <div class="card">
                <div class="card-body">
                    <div class="d-flex align-items-center">
                        <h5 class="mb-0"> <i class="lni lni-book"></i> المقرر | تعديل <small class="text-warning">({{$content->title}})</small> </h5>
                    </div>
                    <div class="row g-3 mt-4">
                        <div class="col-12">
                            <div class="card shadow-none bg-light border">
                                <div class="card-body">
                                    <form class="row g-3" id="validateForm" method="post" enctype="multipart/form-data"
                                          action="{{route('scheduleds.update', $content->id)}}">
                                        @method('put')
                                        @csrf

                                        <div class="col-12">
                                            <label class="form-label">  اختر المنهج <span class="text-danger">*</span> </label>
                                            <select class="form-control" name="curriculum_id">
                                                <option value="">اختر المنهج</option>
                                                @foreach($curriculums as $key=>$val)
                                                    <option @if($val == $content->curriculum_id) selected @endif  value="{{$val}}">{{$key}}</option>
                                                @endforeach
                                            </select>
                                        </div>

                                        <div class="col-12">
                                            <label class="form-label">  اختر المجال <span class="text-danger">*</span> </label>
                                            <select class="form-control" name="category_id">
                                                <option value="">اختر المجال</option>
                                                @foreach($categories as $key=>$val)
                                                    <option @if($val == $content->category_id) selected @endif value="{{$val}}">{{$key}}</option>
                                                @endforeach
                                            </select>
                                        </div>

                                        @include('admin_dashboard.inputs.edit_title')
                                        @include('admin_dashboard.inputs.edit_short_description')
                                        @include('admin_dashboard.inputs.edit_image')
                                        @include('admin_dashboard.inputs.edit_SEO_inputs')
                                        @include('admin_dashboard.inputs.edit_status_sort')
                                        @include('admin_dashboard.inputs.edit_multiple_files')
                                        @include('admin_dashboard.inputs.edit_btn')
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div><!--end row-->
                </div>
            </div>
        </div>
    </div>

@endsection

@push('scripts')
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.5/jquery.validate.min.js" integrity="sha512-rstIgDs0xPgmG6RX1Aba4KV5cWJbAMcvRCVmglpam9SoHZiUCyQVDdH2LPlxoHtrv17XWblE/V/PP+Tr04hbtA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

    <script>
        $(document).ready(function () {
            $("#validateForm").validate({
                rules: {
                    title: {
                        required: true,
                    },
                    short_description: {
                        required: true,
                    },
                    description: {
                        required: true,
                    }

                },
                messages: {
                    title: {
                        required: "الحقل مطلوب",
                    },
                    short_description: {
                        required: "الحقل مطلوب",
                    },
                    description: {
                        required: "الحقل مطلوب",
                    }

                }
            });
        });
    </script>
@endpush

resources/views/admin_dashboard/scheduleds/index.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title')  المقرر @endsection

@section('content')


    <div class="card">
        <div class="card-body">
            <div class="d-flex align-items-center">
                <h5 class="mb-0"> <i class="lni lni-book"></i> المقرر </h5>
                <div class="ms-auto position-relative">
                    <a href="{{route('scheduleds.create')}}" class="btnIcon btn btn-outline-primary px-5"><i class="lni lni-circle-plus"></i> أضف عنصر جديد </a>
                </div>
            </div>
            <div class="table-responsive mt-4">
                <table class="table align-middle">
                    <thead class="table-secondary">
                    <tr>
                        <th>#</th>
                        <th>الصورة</th>
                        <th>المنهج</th>
                        <th>المجال</th>
                        <th>العنوان</th>
                        <th>الحالة</th>
                        <th>الترتيب</th>
                        <th>التحكم</th>
                    </tr>
                    </thead>
                    <tbody>
                        @forelse($content as $con)
                        <tr>
                            <td>{{$con->id}}</td>
                            <td>
                                <div class="d-flex align-items-center gap-3 cursor-pointer">
                                    <img src="{{ assetURLFile($con->image) }}" class="rounded-circle" width="44" height="44" alt="">
                                </div>
                            </td>
                            <td>{{$con->curriculum?->title}}</td>
                            <td>{{$con->category?->title}}</td>
                            <td>{{$con->title}}</td>
                            <td><span class="badge @if($con->status == 'yes') bg-light-success text-success @else bg-light-danger text-danger @endif w-50">
                                    {{ $con->status == 'yes' ? 'مفعل' : 'غير مفعل' }}</span></td>
                            <td>{{$con->sort}}</td>
                            <td>
                                <div class="table-actions d-flex align-items-center gap-3 fs-6">
                                    <a href="{{route('scheduleds.edit', $con->id)}}" class="text-warning" data-bs-toggle="tooltip" data-bs-placement="bottom"
                                       title="تعديل"><i class="bi bi-pencil-fill"></i></a>
                                    <a href="javascript:;"  data-bs-toggle="modal" data-bs-target="#deleteItem{{$con->id}}" class="text-danger" data-bs-toggle="tooltip"
                                       data-bs-placement="bottom" title="حذف"><i class="bi bi-trash-fill"></i></a>
                                    <div class="modal fade" id="deleteItem{{$con->id}}" tabindex="-1" aria-labelledby="link{{$con->id}}" aria-hidden="true">
                                        <div class="modal-dialog modal-dialog-centered">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title" id="link{{$con->id}}">هل أنت متأكد من حذف هذا العنصر ؟</h5>
                                                    <button class="btn-close" type="button" data-bs-dismiss="modal" aria-label="Close"></button>
                                                </div>
                                                <div class="modal-footer">
                                                    <button class="btn btn-outline-default btn-sm me-2" type="button" data-bs-dismiss="modal">لا</button>
                                                    <form action="{{route('scheduleds.destroy',$con->id)}}" method="POST">
                                                        @method('DELETE')
                                                        @csrf
                                                        <button type="submit" class="btn btn-outline-danger btn-sm" type="button">نعم</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                            </td>
                        </tr>
                        @empty
                            <tr>
                                <td colspan="7" class="text-center">
                                    <p> لا يوجد بيانات </p>
                                </td>
                            </tr>
                        @endforelse
                    </tbody>
                </table>
                <div>
                    {{$content->links()}}
                </div>
            </div>
        </div>
    </div>


@endsection